VERSION 5.00
Begin VB.Form frmPrint 
   Caption         =   "Run Services"
   ClientHeight    =   1740
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   3465
   Icon            =   "frmPrint.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   1740
   ScaleWidth      =   3465
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.ComboBox cboPrinter 
      Height          =   315
      ItemData        =   "frmPrint.frx":030A
      Left            =   180
      List            =   "frmPrint.frx":030C
      TabIndex        =   3
      Text            =   "Choose Printer"
      Top             =   420
      Width           =   3135
   End
   Begin VB.ComboBox txtTime 
      Height          =   315
      ItemData        =   "frmPrint.frx":030E
      Left            =   1560
      List            =   "frmPrint.frx":0310
      TabIndex        =   2
      Text            =   "Time"
      Top             =   1260
      Width           =   1035
   End
   Begin VB.ComboBox cmbAmPm 
      Height          =   315
      ItemData        =   "frmPrint.frx":0312
      Left            =   2640
      List            =   "frmPrint.frx":031C
      TabIndex        =   1
      Text            =   "AM"
      Top             =   1260
      Width           =   675
   End
   Begin VB.ComboBox cmbDay 
      Height          =   315
      ItemData        =   "frmPrint.frx":0328
      Left            =   180
      List            =   "frmPrint.frx":0341
      TabIndex        =   0
      Text            =   "Monday"
      Top             =   1260
      Width           =   1335
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   3000
      Top             =   900
   End
   Begin VB.Label Label2 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "At this time:"
      Height          =   315
      Left            =   1560
      TabIndex        =   6
      Top             =   960
      Width           =   1755
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Run on:"
      Height          =   315
      Left            =   180
      TabIndex        =   5
      Top             =   960
      Width           =   1335
   End
   Begin VB.Label lblPort 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Printer Port:"
      Height          =   315
      Left            =   180
      TabIndex        =   4
      Top             =   120
      Width           =   3135
      WordWrap        =   -1  'True
   End
   Begin VB.Menu mnuViewLog 
      Caption         =   "Log File"
      Index           =   1
   End
   Begin VB.Menu mnuPrint 
      Caption         =   "Print Now"
      Index           =   2
   End
   Begin VB.Menu mPopupSys 
      Caption         =   "&SysTray"
      Visible         =   0   'False
      Begin VB.Menu mPopRestore 
         Caption         =   "&Restore"
      End
      Begin VB.Menu mPopExit 
         Caption         =   "&Exit"
      End
   End
End
Attribute VB_Name = "frmPrint"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpszOp As String, ByVal lpszFile As String, ByVal lpszParams As String, ByVal lpszDir As String, ByVal FsShowCmd As Long) As Long
'Private Declare Function GetDesktopWindow Lib "user32" () As Long

Private Sub cboPrinter_Click()
Change_Printer
End Sub

Private Sub Form_Unload(Cancel As Integer)
'delete icon from systray
Shell_NotifyIcon NIM_DELETE, nid

'save all user input to schedule.ini
resp = writeini("when", "AP", cmbAmPm.Text, App.Path & "\schedule.ini") 'morning or evening
resp = writeini("when", "day", cmbDay.Text, App.Path & "\schedule.ini") 'what day to execute on
resp = writeini("when", "time", txtTime.Text, App.Path & "\schedule.ini") 'time to execute
resp = writeini("printer", "name", cboPrinter.Text, App.Path & "\schedule.ini") 'printer name

End Sub

Private Sub Form_Load()

Dim printername As String, P As Printer
    'get printer name from schedule.ini file
    printername = readini("printer", "name", App.Path & "\schedule.ini")

'if no printer name found in schedule.ini file
If printername = "" Then
    'use default printer
    cboPrinter.Text = Printer.DeviceName
    Else
        'use the printer name from schedule.ini
        cboPrinter.Text = printername
End If

'load cboPrinter with installed printer names
For Each P In Printers
    ' Skip any printers you don't want to appear in the combo box.
    If P.DeviceName = "Rendering Subsystem" Then
         'Don't add it to the combo box.
    Else
        ' Add any printers you do want to appear in the combo box.
        cboPrinter.AddItem P.DeviceName
    End If
Next

Change_Printer

'check to see if schedule.ini file exists
If FileExists(App.Path & "\schedule.ini") = False Then
    
    'load data to combo boxes
    cmbDay.Text = Format(Date, "dddd")
    cmbAmPm.Text = Format(Date, "AM/PM")
    
    'create the scedule.ini file
    Set TextStream = CreateObject("Scripting.FileSystemObject")
    Set oFile = TextStream.CreateTextFile(App.Path & "\schedule.ini", True)
    oFile.Close
    
    'write the headings and temp data in schedule.ini file
    resp = writeini("when", "day", cmbDay.Text, App.Path & "\schedule.ini")
    resp = writeini("when", "AP", cmbAmPm.Text, App.Path & "\schedule.ini")
    resp = writeini("when", "time", "12:00:00", App.Path & "\schedule.ini")
        
        Else
            'schedule.ini exists so get the data from it
            cmbDay.Text = readini("when", "day", App.Path & "\schedule.ini")
            txtTime.Text = readini("when", "time", App.Path & "\schedule.ini")
            cmbAmPm.Text = readini("when", "AP", App.Path & "\schedule.ini")

End If

'fill cboTime with times
For i = 1 To 12
    txtTime.AddItem (i & ":00:00")
Next i


       'the form must be fully visible before calling Shell_NotifyIcon
       Me.Show
       Me.Refresh
       With nid
        .cbSize = Len(nid)
        .hwnd = Me.hwnd
        .uId = vbNull
        .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
        .uCallBackMessage = WM_MOUSEMOVE
        .hIcon = Me.Icon
        .szTip = "Print Scheduler" & vbNullChar
       End With
       Shell_NotifyIcon NIM_ADD, nid
      End Sub

      Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
      'this procedure receives the callbacks from the System Tray icon.
      Dim Result As Long
      Dim msg As Long
       'the value of X will vary depending upon the scalemode setting
       If Me.ScaleMode = vbPixels Then
        msg = X
       Else
        msg = X / Screen.TwipsPerPixelX
       End If
       Select Case msg
        Case WM_LBUTTONUP        '514 restore form window
         Me.WindowState = vbNormal
         Result = SetForegroundWindow(Me.hwnd)
         Me.Show
        Case WM_LBUTTONDBLCLK    '515 restore form window
         Me.WindowState = vbNormal
         Result = SetForegroundWindow(Me.hwnd)
         Me.Show
        Case WM_RBUTTONUP        '517 display popup menu
         Result = SetForegroundWindow(Me.hwnd)
         Me.PopupMenu Me.mPopupSys
       End Select
      End Sub

      Private Sub Form_Resize()
       'this is necessary to assure that the minimized window is hidden
       If Me.WindowState = vbMinimized Then Me.Hide
      End Sub

Private Sub mnuPrint_Click(Index As Integer)
'print now
SendPrintJob
MsgBox "Document has been sent to the selected printer."
End Sub

      Private Sub mPopExit_Click()
       'called when user clicks the popup menu Exit command
       Unload Me
      End Sub

      Private Sub mPopRestore_Click()
       'called when the user clicks the popup menu Restore command
       Dim Result As Long
       Me.WindowState = vbNormal
       Result = SetForegroundWindow(Me.hwnd)
       Me.Show
      End Sub

Private Sub mnuViewLog_Click(Index As Integer)
    'check if print_log.txt exists
    If FileExists(App.Path & "\print_log.txt") = False Then
        'does not exist so create it
        Set fs = CreateObject("Scripting.FileSystemObject")
        Set ts = fs.CreateTextFile(App.Path & "\print_log.txt", True)
        MsgBox "Print log not found. A new one has been created"
        ts.WriteLine ("This log was created on " & Date & "." & vbCr)
        ts.Close
        frmLog.Show
            Else
            'print_log.txt found so show frmLog to view its contents
            frmLog.Show
    End If
End Sub

Private Sub Timer1_Timer()

'show current time in forms caption
Me.Caption = Format(Now, "dddd h:mm:ss AM/PM")

'when user selected time and day matches current time and day _
    execute the SendPrintJob function
If Me.Caption = cmbDay.Text & " " & txtTime.Text & " " & cmbAmPm.Text Then
    SendPrintJob
End If
End Sub

Function SendPrintJob()
    'print the color wheel on frmCwheel
    Printer.PaintPicture frmCwheel.cwheel.Picture, 0, 0
      Printer.EndDoc
      Unload frmCwheel
    
    'update the print log
    Const ForReading = 1, ForWriting = 2
    Dim log_text As String
    'make sure file exists before trying to write to it
    Set fs = CreateObject("Scripting.FileSystemObject")
    If FileExists(App.Path & "\print_log.txt") = False Then
        'file not found so create one
        Set ts = fs.CreateTextFile(App.Path & "\print_log.txt", True)
        ts.Close
    Else
    
    'read the contents of the the print log and store as a _
        string named log_text
    Set ts = fs.OpenTextFile(App.Path & "\print_log.txt")
        With ts
            Do Until .AtEndOfStream
                log_text = log_text & .ReadLine & vbCrLf
            Loop
        End With
    End If
    
    'rewrite the log with the current entry appended to it
    Set ts = fs.OpenTextFile(App.Path & "\print_log.txt", ForWriting, True)
    ts.WriteLine (log_text & "=== " & Date & " - printed test page" & vbCrLf)
    ts.Close
    log_text = ""

End Function

Private Function FileExists(FullFileName As String) As Boolean
    On Error GoTo MakeF
        'If file does Not exist, there will be an Error
        Open FullFileName For Input As #1
        Close #1
        'no error, file exists
        FileExists = True
    Exit Function
MakeF:
        'error, file does Not exist
        FileExists = False
    Exit Function
End Function

Function Change_Printer()
Dim P As Printer
' Loop through the printers collection and check each printer name.
For Each P In Printers
 ' If the printers collection name matches the printer selected in the
 ' combo box, display it's port.
 If P.DeviceName = cboPrinter.Text Then
      Set Printer = P
      lblPort.Caption = "Printer Port: " & P.Port
      Exit For
 End If
Next

'write the selected printer name to the schedule.ini file
resp = writeini("printer", "name", cboPrinter.Text, App.Path & "\schedule.ini")
End Function
